type 'a frozen = lazy 'Frozen of 'a;;
let f (x,'Frozen y) = if x<0 then x+y else x;;
f(3,'Frozen(loop 4)) where rec loop x = 1 + loop x;;
let unfreeze ('Frozen x) = x;;
type 'a stream = lazy 'Stream of 'a * 'a stream;;
let rec nth_stream n ('Stream(hd,tl)) =
    if n=1 then hd else nth_stream (n-1) tl;;
let rec map_stream f ('Stream(hd,tl)) =
    'Stream(f hd, map_stream f tl);;
let rec ('Stream(_,Ints)) =
         'Stream(0,'Stream(1, map_stream succ Ints));;
let ('Stream(one,_)) = Ints in one;;
Ints;;
let rec consume n stream = 
    if n=0 then []
    else let ('Stream(x,y)) = stream in x::consume (n-1) y;;
consume 10 Ints;;
let rec map_stream2 f ('Stream(hd1,tl1)) ('Stream(hd2,tl2))
      = 'Stream(f hd1 hd2, map_stream2 f tl1 tl2);;
let rec ('Stream(_,('Stream(_,Fib1) as Fib)))
       = 'Stream(0,'Stream(1,'Stream(1,map_stream2 add Fib Fib1)));;
consume 10 Fib;;
type 'a lazy_stream = {lazy item:'a; lazy rest:'a lazy_stream};;
let rec map_stream f {item=hd; rest=tl} 
     = {item=f hd; rest=map_stream f tl};;
let rec {item=_; rest=Ints} 
     =  {item=0; rest={item=1;rest= map_stream succ Ints}};;
Ints.rest.rest.item;;
